import { FieldInfo } from 'model-util-base'
import { ConditionUtil, ConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, JoinTable, SubTable } from 'model-util'
import { Container, Singleton } from 'typescript-ioc' 
import { CnProjectPack } from '../models/index' 
/**
 * @author auto generate
 * @version 1.0
 * @date 2021-06-03 10:21
 */
interface CnProjectPackCU extends ConditionUtil<CnProjectPackCU>{
    ID:FieldUtil<CnProjectPackCU>;
    PROJECT_NAME:FieldUtil<CnProjectPackCU>;
    BRANCH_NAME:FieldUtil<CnProjectPackCU>;
    DOWN_URL:FieldUtil<CnProjectPackCU>;
    LABEL:FieldUtil<CnProjectPackCU>;
    REMARK:FieldUtil<CnProjectPackCU>;
    DELETED:FieldUtil<CnProjectPackCU>;
    CREATE_USER_ID:FieldUtil<CnProjectPackCU>;
    CREATE_TIME:FieldUtil<CnProjectPackCU>;
}

class CnProjectPackCUImpl extends ConditionUtilImpl<CnProjectPackCUImpl> implements CnProjectPackCU{ 
    newInstance(): CnProjectPackCUImpl {
        return new CnProjectPackCUImpl();
    } 
    get ID(): FieldUtil<CnProjectPackCU>{  
        return new FieldUtil('id','id','主键', this);
    }
    get PROJECT_NAME(): FieldUtil<CnProjectPackCU>{  
        return new FieldUtil('project_name','projectName','项目名称', this);
    }
    get BRANCH_NAME(): FieldUtil<CnProjectPackCU>{  
        return new FieldUtil('branch_name','branchName','分支名称', this);
    }
    get DOWN_URL(): FieldUtil<CnProjectPackCU>{  
        return new FieldUtil('down_url','downUrl','下载地址', this);
    }
    get LABEL(): FieldUtil<CnProjectPackCU>{  
        return new FieldUtil('label','label','标签', this);
    }
    get REMARK(): FieldUtil<CnProjectPackCU>{  
        return new FieldUtil('remark','remark','备注', this);
    }
    get DELETED(): FieldUtil<CnProjectPackCU>{  
        return new FieldUtil('deleted','deleted','删除标记', this);
    }
    get CREATE_USER_ID(): FieldUtil<CnProjectPackCU>{  
        return new FieldUtil('create_user_id','createUserId','创建人', this);
    }
    get CREATE_TIME(): FieldUtil<CnProjectPackCU>{  
        return new FieldUtil('create_time','createTime','创建时间', this);
    }
}

@Singleton 
class CnProjectPackMU extends TableUtilImpl<CnProjectPackCU,CnProjectPack>{ 
    tableName  = 'cn_project_pack';
    tableFields  = ['id','project_name','branch_name','down_url','label','remark','deleted','create_user_id','create_time'];
    modelFields  = ['id','projectName','branchName','downUrl','label','remark','deleted','createUserId','createTime'];
    modelIdFields  = ['id'];
    tableIdFields  = ['id'];
    idType = IdType.CUSTOM;
    joinTables = [];
    subTables = [];

    createConditionUtil(): CnProjectPackCU {
        return new CnProjectPackCUImpl();
    }   

    static get ID(): FieldUtil<CnProjectPackCU>{ 
        return new FieldUtil('id','id','主键', new CnProjectPackCUImpl());
    }
    static get PROJECT_NAME(): FieldUtil<CnProjectPackCU>{ 
        return new FieldUtil('project_name','projectName','项目名称', new CnProjectPackCUImpl());
    }
    static get BRANCH_NAME(): FieldUtil<CnProjectPackCU>{ 
        return new FieldUtil('branch_name','branchName','分支名称', new CnProjectPackCUImpl());
    }
    static get DOWN_URL(): FieldUtil<CnProjectPackCU>{ 
        return new FieldUtil('down_url','downUrl','下载地址', new CnProjectPackCUImpl());
    }
    static get LABEL(): FieldUtil<CnProjectPackCU>{ 
        return new FieldUtil('label','label','标签', new CnProjectPackCUImpl());
    }
    static get REMARK(): FieldUtil<CnProjectPackCU>{ 
        return new FieldUtil('remark','remark','备注', new CnProjectPackCUImpl());
    }
    static get DELETED(): FieldUtil<CnProjectPackCU>{ 
        return new FieldUtil('deleted','deleted','删除标记', new CnProjectPackCUImpl());
    }
    static get CREATE_USER_ID(): FieldUtil<CnProjectPackCU>{ 
        return new FieldUtil('create_user_id','createUserId','创建人', new CnProjectPackCUImpl());
    }
    static get CREATE_TIME(): FieldUtil<CnProjectPackCU>{ 
        return new FieldUtil('create_time','createTime','创建时间', new CnProjectPackCUImpl());
    }

    get ID(): FieldUtil<CnProjectPackCU>{ 
        return CnProjectPackMU.ID;
    }
    get PROJECT_NAME(): FieldUtil<CnProjectPackCU>{ 
        return CnProjectPackMU.PROJECT_NAME;
    }
    get BRANCH_NAME(): FieldUtil<CnProjectPackCU>{ 
        return CnProjectPackMU.BRANCH_NAME;
    }
    get DOWN_URL(): FieldUtil<CnProjectPackCU>{ 
        return CnProjectPackMU.DOWN_URL;
    }
    get LABEL(): FieldUtil<CnProjectPackCU>{ 
        return CnProjectPackMU.LABEL;
    }
    get REMARK(): FieldUtil<CnProjectPackCU>{ 
        return CnProjectPackMU.REMARK;
    }
    get DELETED(): FieldUtil<CnProjectPackCU>{ 
        return CnProjectPackMU.DELETED;
    }
    get CREATE_USER_ID(): FieldUtil<CnProjectPackCU>{ 
        return CnProjectPackMU.CREATE_USER_ID;
    }
    get CREATE_TIME(): FieldUtil<CnProjectPackCU>{ 
        return CnProjectPackMU.CREATE_TIME;
    }
}
export {CnProjectPackMU, CnProjectPackCU}
